<?php
/**
 * @package    JMyLife
 * @subpackage Components
 * @version    1.0.16
 * @copyright  2009-2010 Jeff Channell
 * administrator/components/com_jmylife/models/configuration.php
 * @license

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

 */
// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );
jimport('joomla.filesystem.file');
jimport('joomla.filesystem.folder');

/**
 * Configuration Model
 *
 * @package    JMyLife
 * @subpackage Components
 */
class JmylifeModelConfiguration extends JModel
{
	/**
	 * config list
	 * @var array
	 */
	var $_config = null;

	var $_graphical_voting_size = null;

	/**
	 * contructor
	 */
	function __construct()
	{
		parent::__construct();
  }
	/**
	 * builds query
	 * @return string
	 *
	 */
	function _buildQuery()
	{
		// build query
		// ordering & sorting since 1.0.4
		// language join in 1.0.11
		// NOTE: each language needs an extry in config!
		return 'SELECT c.`key`, c.`group`, c.`subgroup`, c.`ordering`, c.`type`, c.`label`, c.`description`, IF( ln.`value` IS NOT NULL, ln.`value`, c.`value` ) AS value FROM `#__jmylife_configuration` AS c LEFT JOIN `#__jmylife_language` AS ln ON ( CONVERT( c.`key` USING utf8 ) = CONVERT( ln.`key` USING utf8 ) ) GROUP BY c.`key` ORDER BY c.`group` ASC, c.`subgroup` ASC, c.`ordering` ASC, c.`key` ASC ';
	}

	/**
	 * builds group query
	 * @return string
	 * @since 1.0.5
	 *
	 */
	function _buildGroupQuery()
	{
		// build query
		// ordering & sorting since 1.0.4
		$query = 'SELECT '
		       . '`group` '
		       . 'FROM `#__jmylife_configuration` '
		       . 'GROUP BY `group` '
		       ;
		return $query;
	}

	/**
	 * Gets the list data
	 * @return stdClass object of listings
	 *
	 * @todo use Joomla Tables instead of simple queries
	 */
	function getConfig()
	{
		// if data hasn't already been obtained, load it
		if( empty( $this->_config ) )
		{
			$query = $this->_buildQuery();
			$this->_config = $this->_getList( $query, 0, 99999 );
		}
		return $this->_config;
	}

	/**
	 * Gets groups
	 * @return stdClass object of listings
	 * @since 1.0.5
	 *
	 */
	function getGroups()
	{
		// if data hasn't already been obtained, load it
		if( empty( $this->_groups ) )
		{
			$query = $this->_buildGroupQuery();
			$this->_groups = $this->_getList( $query, 0, 99999 );
		}
		return $this->_groups;
	}
	
	/**
	 * Builds a select element for graphical vote sizes
	 * @since 1.0.10
	 */
	function getGraphicalVotingSize()
	{
		$_JMLConfig = JmylifeConfiguration::getInstance();
		if( empty( $this->_graphical_voting_size ) )
		{
			$choices = array(
				JHTML::_('select.option', '48', JText::_('COM_JMYLIFE_CONFIGURATION_GRAPHICALVOTINGOPTION_LARGE') ),
				JHTML::_('select.option', '36', JText::_('COM_JMYLIFE_CONFIGURATION_GRAPHICALVOTINGOPTION_MEDIUM') ),
				JHTML::_('select.option', '24', JText::_('COM_JMYLIFE_CONFIGURATION_GRAPHICALVOTINGOPTION_SMALL') ),
			);
			$this->_graphical_voting_size = JHTML::_( 'select.genericlist', $choices, 'graphical_voting_size', '', 'value', 'text', $_JMLConfig->get( 'graphical_voting_size', '48' ), 'graphical_voting_size' );
		}
		return $this->_graphical_voting_size;
	}
	
}